<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Student_Index extends Controller_Environment_Student
{
    public function action_index() {
        $disciplines = $this->studentInfo->getDisciplines();
        $marks = [];

        foreach ($disciplines as $dis) {
            if (isset($dis->Rate) && isset($dis->MaxCurrentRate)) {
                $marks[$dis->ID] = Model_Subject::getECTSMark($dis->Rate, $dis->MaxCurrentRate, $exam = NULL);
                
                if ($dis->Type == Model_Discipline::CREDIT && $dis->Rate >= 60)
                    $marks[$dis->ID] = Model_Subject::MARK_A;
            }
        }

        $teachers = $this->studentInfo->getTeachers();
        foreach ($teachers as $disID => &$list) {
            $list = Controller_Teacher_Index::getShortListOfTeachers($list);
        }

        $this->twig->set([
            'Marks'          => $marks,
            'Disciplines'    => $disciplines,
            'Teachers'       => $teachers,
        ])->set_filename(static::TWIG_FOLDER . 'index');
    }

    public function action_settings() {
        $this->twig->set_filename('settings');
    }
}

